<?php
    if ( !defined('K_COUCH_DIR') ) die(); // cannot be loaded directly

    class KMultiLang{

        static function lang_group_handler( $params, $node ){
            global $FUNCS, $PAGE, $CTX;
            if( count($node->children) ) {die("ERROR: Tag \"".$node->name."\" is a self closing tag");}

            // handle params
            $arr_known_params = array( '_related_by'=>'', '_common_fields'=>'' );
            extract( $FUNCS->get_named_vars(
                        $arr_known_params,
                        $params)
                  );
            $_related_by = trim( $_related_by );
            if( $_related_by=='' ){ $_related_by = 'related_page'; } // default name of the relation field connecting pages
            $_common_fields = trim( $_common_fields );

            $templates = array();
            $main_lang = null;
            foreach( $params as $param ){
                $lang = strtolower( trim($param['lhs']) );
                if( array_key_exists($lang, $arr_known_params) ) continue;

                $tpl_name = trim( $param['rhs'] );
                $ext = strtolower( pathinfo($tpl_name, PATHINFO_EXTENSION) );
                if( $ext=='php' ){
                    $templates[$lang] = $tpl_name;
                    if( is_null($main_lang) ){ $main_lang=$lang; } // first template specified is considered the main template
                }
            }

            if( !count($templates) ) return;

            // get down to work ..
            $k_template_name = $CTX->get( 'k_template_name' );
            $code = '';
            if( $CTX->get('k_is_page') || $CTX->get('k_is_list_page') ){

                // if not the main language template, first get the related main language page
                if( $k_template_name != $templates[$main_lang] ){
                    $code .= "<cms:related_pages '".$_related_by."' limit='1' >";
                }

                // get links to pages of other languages through this main language page
                foreach( $templates as $lang=>$tpl ){
                    if( $lang==$main_lang ){
                        $code .= "<cms:set my_link_".$lang."=k_page_link 'global' />";
                    }
                    else{
                        $code .= "<cms:reverse_related_pages '".$_related_by."' masterpage='".$tpl."' limit='1'>
                            <cms:set my_link_".$lang."=k_page_link 'global' />
                        </cms:reverse_related_pages>";
                    }
                }

                // if not the main language template, get resources from the main language page
                if( $k_template_name != $templates[$main_lang] ){
                    if( $_common_fields!='' ){
                        $_common_fields = array_filter( array_map("trim", explode('|', $_common_fields)) );
                        $str_array = $sep = '';
                        foreach( $_common_fields as $field ){
                            $str_array .= $sep . " '" . $field . "'";
                            $sep = ',';
                        }
                        $code .= '
                        <cms:php>
                            global $CTX;

                            $vars = array( '.$str_array.' );
                            $vars = array_filter( array_map(\'trim\', $vars) );

                            foreach( $vars as $var ){
                                $obj = $CTX->get_object_ex( $var, 1 );
                                if( !is_null($obj) ){
                                    $CTX->set_object( $var, $obj, \'global\' );
                                }
                                else{
                                    $CTX->set( $var, $CTX->get($var, 1), \'global\' );
                                }
                            }
                        </cms:php>
                        ';
                    }
                    $code .= "</cms:related_pages>";
                }
            }
            else{
                foreach( $templates as $lang=>$tpl ){
                    $code .= "<cms:set my_link_".$lang."=\"<cms:link '".$tpl."' />\" 'global' />";
                }
            }

            // pass on the generated Couch code to $FUNCS->embed for execution ..
            $html = $FUNCS->embed( $code, $is_code=1 );

            // return output from the code ..
            return $html;
        }
    }

    $FUNCS->register_tag( 'lang_group', array('KMultiLang', 'lang_group_handler') );
